without trace       
without warning

include get.e       
include misc.e     
 
include ..\me_widgets.e 


package("ME_Demo")

global constant A=class("A",Component,NONE)

property("caption",INSTANCE,PUBLIC,PRIVATE,NONE)

function A_new(object name,object caption)
   entity new
   new=call_super({name}) 
   if failure() then return NOTHING end if
   set_property(new,"caption",caption)
   return new
end function 
method("new",CLASS,PUBLIC,2,routine_id("A_new")) 

super_method("delete",INSTANCE) 

end_class()


constant Savetest=class("Savetest",Entity,NONE)

procedure Savetest_main()    
   entity w,x,y,z,w1,x1,y1,z1 
   integer index                        
   w=call_method(Collection,"new",{A}) 
   x=call_method(A,"new",{"x","the rain in Spain"})
   VOID=call_method(w,"add",{x})
   y=call_method(A,"new",{"y","eye of newt and tounge of bat"}) 
   VOID=call_method(w,"add",{y})
   z=call_method(A,"new",{"z","sanity is highly overrated"}) 
   VOID=call_method(w,"add",{z})
   puts(1,"--- Original Values ---\nentity w:  ")
   ? w   
   printf(1,"entity x's caption property:  %s\n",
   {call_method(x,"get_caption",NONE)})
   printf(1,"entity y's caption property:  %s\n",
   {call_method(y,"get_caption",NONE)})
   printf(1,"entity z's caption property:  %s\n",
   {call_method(z,"get_caption",NONE)})           
   VOID=serialize(w,"save.txt")
   w1=deserialize("save.txt")
   puts(1,"\n--- Restored Values ---\nentity w1:  ") 
   ? w1
   index=call_method(w1,"find",{"x"})
   x1=call_method(w1,"get",{index})
   printf(1,"entity x1's caption property:  %s\n",
   {call_method(x1,"get_caption",NONE)}) 
   index=call_method(w1,"find",{"y"})
   y1=call_method(w1,"get",{index})
   printf(1,"entity y1's caption property:  %s\n",
   {call_method(y1,"get_caption",NONE)}) 
   index=call_method(w1,"find",{"z"})
   z1=call_method(w1,"get",{index})
   printf(1,"entity z1's caption property:  %s\n",
   {call_method(z1,"get_caption",NONE)})           
   puts(1,"\nPress any key to exit.")
   VOID=wait_key() 
end procedure
method("main",CLASS,PRIVATE,0,{routine_id("Savetest_main")})

end_class()


end_package()
    
    
main_program(Savetest)

