-- me_file_errors.e v3.0.0 by Mike Nelson  
-- Requires Euphoria 2.5  
-- Method Euphoria Standard Class Library      
-- Useful exceptions for file operations. 
                 
without trace           
without warning   

include method_euphoria.e 

       
package("ME_Std_Lib")
package("File_Errors") 


global constant File_Error=exception("File_Error",Exception)

global constant File_Read_Error=exception("File_Read_Error",File_Error)

global constant File_Write_Error=exception("File_Write_Error",File_Error)

global constant File_Open_Error=exception("File_Open_Error",File_Error)

global constant File_Lock_Error=exception("File_Lock_Error",File_Error) 

global constant Bad_File_Path=exception("Bad_File_Path",File_Error)

global constant End_Of_File=exception("End_Of_File",File_Error)  

 
end_package()
end_package()  


  

