-- me_variables.e v3.0.0 by Mike Nelson  
-- Requires Euphoria 2.5  
-- Method Euphoria Standard Class Library   
-- Reference variables and constants with events.     
             
without trace
without warning
                  
include method_euphoria.e 


package("ME_Std_Lib") 
package("Variables")  
 
 
global constant Variable=class("Variable",Entity,NONE) 

property("data",INSTANCE,PROTECTED,PROTECTED,NOTHING) 

event("read",PUBLIC,PRIVATE) 
event("write",PUBLIC,PRIVATE)

function Variable_new(object data)
   entity new 
   if equal(data,NOTHING) then
      throw(Missing_Parameter)
      return NOTHING   
   end if
   new=call_super(NONE)
   set_property(new,"data",data)   
   return new
end function                
method("new",CLASS,PUBLIC,1,routine_id("Variable_new"))  

super_method("clone",INSTANCE)

super_method("delete",INSTANCE)     

function Variable_get()  
   object data
   data=get_property(this(),"data")
   VOID=call_method(this(),"read",{data})
   return data   
end function  
method("get",INSTANCE,PUBLIC,0,routine_id("Variable_get"))  

procedure Variable_set(object new)
   object old
   old=get_property(this(),"data")
   set_property(this(),"data",new)
   VOID=call_method(this(),"write",{old,new})
end procedure                          
method("set",INSTANCE,PUBLIC,1,{routine_id("Variable_set")})

end_class()


global constant Constant=class("Constant",Variable,NONE) 

function Constant_set()
   return call_super(call_method(this(),"get_data",NONE))   
end function                                             
method("set",INSTANCE,PUBLIC,0,routine_id("Constant_set"))

end_class()                     


end_package()
end_package()   


  

