without trace         
without warning      
    
include get.e
include wildcard.e   
include ..\me_containers.e 
                 
procedure print_list(entity Param) 
   sequence temp
   temp=NONE   
   for i=1 to call_method(Param,"get_size",NONE) do
      temp=append(temp,call_method(Param,"get",{i}))
   end for
   printf(1,"\nList of people working on object orientation for "
   &"Euphoria:\n",{})
   printf(1,"%s",{repeat('-',80)})
   printf(1,"%-27s%-20s\n",{"NAME","PROGRAM"})
   printf(1,"%s",{repeat('-',80)})
   for i=1 to length(temp) do
      printf(1,"%-27s%-20s\n",temp[i])
   end for
   printf(1,"%s\n\n",{repeat('-',80)})
end procedure 
  

package("ME_Demo")


constant Demo=class("Demo",Entity,NONE)

procedure Demo_main() 
   integer p 
   sequence temp
   entity a,b,c,d,e,f,g 
   a=call_method(Multi_Set,"new",NONE)
   temp={14,67,12,{45,33},102,-5,{17,16,76},{17,16},0,0}
   print(1,temp)
   puts(1,'\n')
   for i=1 to length(temp)  do
      VOID=call_method(a,"add",{temp[i]})
   end for
   puts(1,"{") 
   for i=1 to call_method(a,"get_size",NONE) do
      if i!=1 then puts(1,",") end if  
      print(1,call_method(a,"get",{i}))
   end for
   puts(1,"}\n")    
   b=call_method(Set,"new",NONE) 
   for i=1 to length(temp) do
      VOID=call_method(b,"add",{temp[i]})
      if catch(Duplicate_Element) then
         printf(1,"Duplicate item removed:  ",{})
         print(1,temp[i])
         puts(1,'\n')
      end if
   end for
   puts(1,"{")
   for i=1 to call_method(b,"get_size",NONE) do
      if i!=1 then puts(1,",") end if
      print(1,call_method(b,"get",{i}))
   end for
   puts(1,"}\n")
   puts(1,"\n\nPress any key to continue . . .")
   VOID=wait_key()
   clear_screen()
   c=call_method(Map,"new",NONE)
   temp={
   {"Nelson, Mike","method_euphoria.e"},
   {"Nelson, Mike"},
   {"Jackson, Rod","Quartz.e"},
   {"Whitehead, Matthew","ObjEu.e"},
   {"Janes, Jurgen","OOLib.e"},
   {"Cuny, David","llama.ew"},
   {"Bussiere, Francis","classes.e"},
   {"Niewenhuijsen, Ralf","oop.e (1)"},
   {"Otto, Joe","Oop.e (2)"},
   {"Smith, Ian","sympel.e"},
   {"Bochert, Karl","Bach interpreter"},
   {"Lewis, Matt","ooeu interpreter"},
   {"Probert, Dave","zclasses.ew"},
   {"Steele, Mario","SOOP.e"}
   }
   for i=1 to length(temp) do
      VOID=call_method(c,"add",{upper(temp[i][1]),temp[i]})
      if catch(Duplicate_Element) then
         printf(1,"Key %s already in Map.\n",
         temp[i])
      end if
   end for
   temp=NONE
   for i=1 to call_method(c,"get_size",NONE) do
      temp=append(temp,call_method(c,"get",{i}))
   end for
   puts(1,"\nSorted by Name:")
   print_list(c)
   puts(1,"Press any key to continue . . .")
   VOID=wait_key()
   clear_screen()
   d=call_method(Map,"new",NONE)
   for i=1 to length(temp) do
      VOID=call_method(d,"add",{upper(temp[i][2]),temp[i]})
   end for
   puts(1,"Sorted by Program:")
   print_list(d)
   puts(1,"Press any key to continue . . .")
   VOID=wait_key()
   clear_screen()
   e=call_method(Stack,"new",NONE)
   f=call_method(Queue,"new",NONE)
   for i=1 to 10 do
      VOID=call_method(e,"add",{i})
      VOID=call_method(f,"add",{i})
      printf(1,"Inserting %d\t",i)
   end for
   printf(1,"\nPop Stack\tPop Queue",NONE)
   for i=1 to 10 do
      printf(1,"\n%2d\t\t%2d",{call_method(e,"remove",NONE),
      call_method(f,"remove",NONE)})
   end for
   puts(1,'\n')     
   puts(1,"Press any key to continue . . .")
   VOID=wait_key()
   clear_screen()
   g=call_method(Priority_Queue,"new",NONE)
   for i='A' to 'Z' do   
      p=rand(5)
      VOID=call_method(g,"add",{{i,p},p})    
   end for 
   puts(1,"The alphabet inserted into a priority queue in order\n"
   &"with random priorities:\n")
   for i=1 to 26 do
      printf(1,"{%s,%d}\t",call_method(g,"remove",NONE))    
   end for
   puts(1,"\n\nPress any key to exit.\n")
   VOID=wait_key() 
end procedure
method("main",CLASS,PRIVATE,0,{routine_id("Demo_main")})

end_class()


end_package()
 
 
main_program(Demo)


