without trace    
without warning 
                    
include machine.e
include get.e
include animal.e    

constant fmt="%7d %-43s%9.6f\n"
atom itorcount,MEAccess
integer fn

procedure specprint(sequence text)
   printf(1,fmt,{itorcount,"iterations of Method Euphoria "&text&":",MEAccess})
   printf(fn,fmt,{itorcount,"iterations of Method Euphoria "&text&":",MEAccess}) 
end procedure


package("ME_Demo")


constant Speed_Test=class("Speed_Test",Entity,NONE)

procedure Speed_Test_main()
   sequence d  
   sequence G
   atom LoopOverhead,CallOverhead,t
   sequence Kitty,KittyClone
   sequence KittyHandle
   tick_rate(100) 
   fn=open("speedtst.log","a")
   d=date()
   printf(fn,"[Method Euphoria v%d.%d.%d %02d/%02d/%04d %02d:%02d:%02d]\n",
   CURRENT_VERSION&{d[2],d[3],d[1]+1900,d[4],d[5],d[6]})
   clear_screen()
   while 1 do
      itorcount=prompt_number("Enter the number of iterations (100-1000000): ",
      {100,1000000})
      if integer(itorcount) then exit end if
      puts(1,"An integer is expected here - try again\n")
   end while 
   puts(1,"\n")
   Kitty = call_method(Cat,"new",{"Lucky",TRUE,TRUE,TRUE,FALSE})  
   LoopOverhead = time ()
   for i = 1 to itorcount do end for
   LoopOverhead = time () - LoopOverhead
   MEAccess = time () 
   VOID=call_method(Kitty,"set_declawed",{0})
   CallOverhead = time()-MEAccess
   MEAccess=time()
   VOID=call_method(Kitty,"set_declawed",{itorcount})
   MEAccess = time () - MEAccess - LoopOverhead - CallOverhead
   specprint("set_property()")
   MEAccess = time () 
   VOID=call_method(Kitty,"get_declawed",{0})
   CallOverhead = time()-MEAccess
   MEAccess=time()
   VOID=call_method(Kitty,"get_declawed",{itorcount})
   MEAccess = time () - MEAccess - LoopOverhead - CallOverhead
   specprint("get_property()")
   MEAccess = time ()
   for i = 1 to itorcount do
      VOID=call_method (Kitty, "make_noise",NONE)
   end for
   MEAccess = time () - MEAccess - LoopOverhead
   specprint("call_method()") 
   MEAccess = time ()      
   for i = 1 to itorcount do
      KittyHandle=call_method(Cat,"new",{"Lucky",TRUE,TRUE,TRUE,FALSE})
   end for
   MEAccess = time () - MEAccess - LoopOverhead
   specprint("constructor")  
   for i = 3 to itorcount+2 do
      KittyHandle[2]=i
      VOID=call_method(KittyHandle,"delete",NONE)
   end for
   MEAccess=time()
   for i = 1 to itorcount do
      KittyClone=call_method(Kitty,"clone",NONE)
   end for
   MEAccess=time()-MEAccess-LoopOverhead
   specprint("copy constructor")   
   t=time()
   for i=itorcount+3 to itorcount*2+2 do
      KittyHandle[2]=i
   end for
   LoopOverhead+=time()-t
   MEAccess = time ()
   for i = itorcount+3 to itorcount*2+2 do
      KittyHandle[2]=i
      VOID=call_method(KittyHandle,"delete",NONE)
   end for
   MEAccess = time () - MEAccess - LoopOverhead
   specprint("destructor") 
   close(fn)
   puts(1, "\n\nDone.  Press any key to exit.") 
   VOID=wait_key()
end procedure

method("main",CLASS,PRIVATE,0,{routine_id("Speed_Test_main")})

end_class()
         

end_package()         
            
            
main_program(Speed_Test)

